#ifndef _H_5531D5CA2898F11BCA51ABB88D8E85E2_MetricList_DCPS_H_
#define _H_5531D5CA2898F11BCA51ABB88D8E85E2_MetricList_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MetricList_.h"


namespace ros_monitoring_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MetricList_TypeSupportInterface;

            typedef MetricList_TypeSupportInterface * MetricList_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MetricList_TypeSupportInterface> MetricList_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MetricList_TypeSupportInterface> MetricList_TypeSupportInterface_out;


            class MetricList_DataWriter;

            typedef MetricList_DataWriter * MetricList_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MetricList_DataWriter> MetricList_DataWriter_var;
            typedef DDS_DCPSInterface_out < MetricList_DataWriter> MetricList_DataWriter_out;


            class MetricList_DataReader;

            typedef MetricList_DataReader * MetricList_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MetricList_DataReader> MetricList_DataReader_var;
            typedef DDS_DCPSInterface_out < MetricList_DataReader> MetricList_DataReader_out;


            class MetricList_DataReaderView;

            typedef MetricList_DataReaderView * MetricList_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MetricList_DataReaderView> MetricList_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MetricList_DataReaderView> MetricList_DataReaderView_out;

            struct MetricList_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MetricList_, struct MetricList_Seq_uniq_> MetricList_Seq;
            typedef DDS_DCPSSequence_var < MetricList_Seq> MetricList_Seq_var;
            typedef DDS_DCPSSequence_out < MetricList_Seq> MetricList_Seq_out;

            class  MetricList_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MetricList_TypeSupportInterface_ptr _ptr_type;
                typedef MetricList_TypeSupportInterface_var _var_type;

                static MetricList_TypeSupportInterface_ptr _duplicate (MetricList_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricList_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MetricList_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricList_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricList_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MetricList_TypeSupportInterface () {};
                ~MetricList_TypeSupportInterface () {};
            private:
                MetricList_TypeSupportInterface (const MetricList_TypeSupportInterface &);
                MetricList_TypeSupportInterface & operator = (const MetricList_TypeSupportInterface &);
            };

            class  MetricList_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MetricList_DataWriter_ptr _ptr_type;
                typedef MetricList_DataWriter_var _var_type;

                static MetricList_DataWriter_ptr _duplicate (MetricList_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricList_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MetricList_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricList_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricList_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MetricList_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MetricList_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MetricList_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MetricList_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MetricList_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MetricList_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MetricList_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MetricList_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MetricList_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MetricList_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MetricList_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MetricList_& instance_data) = 0;

            protected:
                MetricList_DataWriter () {};
                ~MetricList_DataWriter () {};
            private:
                MetricList_DataWriter (const MetricList_DataWriter &);
                MetricList_DataWriter & operator = (const MetricList_DataWriter &);
            };

            class  MetricList_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MetricList_DataReader_ptr _ptr_type;
                typedef MetricList_DataReader_var _var_type;

                static MetricList_DataReader_ptr _duplicate (MetricList_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricList_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MetricList_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricList_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricList_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MetricList_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MetricList_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MetricList_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MetricList_& instance) = 0;

            protected:
                MetricList_DataReader () {};
                ~MetricList_DataReader () {};
            private:
                MetricList_DataReader (const MetricList_DataReader &);
                MetricList_DataReader & operator = (const MetricList_DataReader &);
            };

            class  MetricList_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MetricList_DataReaderView_ptr _ptr_type;
                typedef MetricList_DataReaderView_var _var_type;

                static MetricList_DataReaderView_ptr _duplicate (MetricList_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricList_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MetricList_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricList_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricList_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MetricList_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MetricList_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MetricList_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MetricList_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MetricList_& instance) = 0;

            protected:
                MetricList_DataReaderView () {};
                ~MetricList_DataReaderView () {};
            private:
                MetricList_DataReaderView (const MetricList_DataReaderView &);
                MetricList_DataReaderView & operator = (const MetricList_DataReaderView &);
            };
        }

    }

}

#endif
