// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ros_monitoring_msgs:msg/MetricData.idl
// generated code does not contain a copyright notice

#ifndef ROS_MONITORING_MSGS__MSG__METRIC_DATA__STRUCT_H_
#define ROS_MONITORING_MSGS__MSG__METRIC_DATA__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNIT_SEC'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_SEC = "sec";

/// Constant 'UNIT_MILLI_SEC'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_MILLI_SEC = "msec";

/// Constant 'UNIT_MICRO_SEC'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_MICRO_SEC = "usec";

/// Constant 'UNIT_PERCENTAGE'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_PERCENTAGE = "percent";

/// Constant 'UNIT_COUNT'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_COUNT = "count";

/// Constant 'UNIT_COUNT_PER_SEC'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_COUNT_PER_SEC = "count_per_sec";

/// Constant 'UNIT_BYTES'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_BYTES = "bytes";

/// Constant 'UNIT_KILOBYTES'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_KILOBYTES = "kilobytes";

/// Constant 'UNIT_MEGABYTES'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_MEGABYTES = "megabytes";

/// Constant 'UNIT_GIGABYTES'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_GIGABYTES = "gigabytes";

/// Constant 'UNIT_TERABYTES'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_TERABYTES = "terabytes";

/// Constant 'UNIT_BYTES_PER_SEC'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_BYTES_PER_SEC = "bytes_per_sec";

/// Constant 'UNIT_KILOBYTES_PER_SEC'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_KILOBYTES_PER_SEC = "kilobytes_per_sec";

/// Constant 'UNIT_MEGABYTES_PER_SEC'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_MEGABYTES_PER_SEC = "megabytes_per_sec";

/// Constant 'UNIT_GIGABYTES_PER_SEC'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_GIGABYTES_PER_SEC = "gigabytes_per_sec";

/// Constant 'UNIT_TERABYTES_PER_SEC'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_TERABYTES_PER_SEC = "terabytes_per_sec";

/// Constant 'UNIT_NONE'.
static const char * const ros_monitoring_msgs__msg__MetricData__UNIT_NONE = "none";

/// Constant 'NA_STRING'.
static const char * const ros_monitoring_msgs__msg__MetricData__NA_STRING = "non_applicable_string_value";

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.h"
// Member 'metric_name'
// Member 'unit'
#include "rosidl_generator_c/string.h"
// Member 'time_stamp'
#include "builtin_interfaces/msg/time__struct.h"
// Member 'dimensions'
#include "ros_monitoring_msgs/msg/metric_dimension__struct.h"

// Struct defined in msg/MetricData in the package ros_monitoring_msgs.
typedef struct ros_monitoring_msgs__msg__MetricData
{
  std_msgs__msg__Header header;
  rosidl_generator_c__String metric_name;
  rosidl_generator_c__String unit;
  double value;
  builtin_interfaces__msg__Time time_stamp;
  ros_monitoring_msgs__msg__MetricDimension__Sequence dimensions;
} ros_monitoring_msgs__msg__MetricData;

// Struct for a sequence of ros_monitoring_msgs__msg__MetricData.
typedef struct ros_monitoring_msgs__msg__MetricData__Sequence
{
  ros_monitoring_msgs__msg__MetricData * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ros_monitoring_msgs__msg__MetricData__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROS_MONITORING_MSGS__MSG__METRIC_DATA__STRUCT_H_
