// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ros_monitoring_msgs:msg/MetricData.idl
// generated code does not contain a copyright notice

#ifndef ROS_MONITORING_MSGS__MSG__METRIC_DATA__STRUCT_HPP_
#define ROS_MONITORING_MSGS__MSG__METRIC_DATA__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"
// Member 'time_stamp'
#include "builtin_interfaces/msg/time__struct.hpp"
// Member 'dimensions'
#include "ros_monitoring_msgs/msg/metric_dimension__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ros_monitoring_msgs__msg__MetricData __attribute__((deprecated))
#else
# define DEPRECATED__ros_monitoring_msgs__msg__MetricData __declspec(deprecated)
#endif

namespace ros_monitoring_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MetricData_
{
  using Type = MetricData_<ContainerAllocator>;

  explicit MetricData_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init),
    time_stamp(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->metric_name = "";
      this->unit = "";
      this->value = 0.0;
    }
  }

  explicit MetricData_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    metric_name(_alloc),
    unit(_alloc),
    time_stamp(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->metric_name = "";
      this->unit = "";
      this->value = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _metric_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _metric_name_type metric_name;
  using _unit_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _unit_type unit;
  using _value_type =
    double;
  _value_type value;
  using _time_stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _time_stamp_type time_stamp;
  using _dimensions_type =
    std::vector<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>, typename ContainerAllocator::template rebind<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>>::other>;
  _dimensions_type dimensions;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__metric_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->metric_name = _arg;
    return *this;
  }
  Type & set__unit(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->unit = _arg;
    return *this;
  }
  Type & set__value(
    const double & _arg)
  {
    this->value = _arg;
    return *this;
  }
  Type & set__time_stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->time_stamp = _arg;
    return *this;
  }
  Type & set__dimensions(
    const std::vector<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>, typename ContainerAllocator::template rebind<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>>::other> & _arg)
  {
    this->dimensions = _arg;
    return *this;
  }

  // constant declarations
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_SEC;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_MILLI_SEC;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_MICRO_SEC;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_PERCENTAGE;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_COUNT;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_COUNT_PER_SEC;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_BYTES;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_KILOBYTES;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_MEGABYTES;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_GIGABYTES;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_TERABYTES;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_BYTES_PER_SEC;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_KILOBYTES_PER_SEC;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_MEGABYTES_PER_SEC;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_GIGABYTES_PER_SEC;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_TERABYTES_PER_SEC;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNIT_NONE;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> NA_STRING;

  // pointer types
  using RawPtr =
    ros_monitoring_msgs::msg::MetricData_<ContainerAllocator> *;
  using ConstRawPtr =
    const ros_monitoring_msgs::msg::MetricData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ros_monitoring_msgs__msg__MetricData
    std::shared_ptr<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ros_monitoring_msgs__msg__MetricData
    std::shared_ptr<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MetricData_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->metric_name != other.metric_name) {
      return false;
    }
    if (this->unit != other.unit) {
      return false;
    }
    if (this->value != other.value) {
      return false;
    }
    if (this->time_stamp != other.time_stamp) {
      return false;
    }
    if (this->dimensions != other.dimensions) {
      return false;
    }
    return true;
  }
  bool operator!=(const MetricData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MetricData_

// alias to use template instance with default allocator
using MetricData =
  ros_monitoring_msgs::msg::MetricData_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_SEC = "sec";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_MILLI_SEC = "msec";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_MICRO_SEC = "usec";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_PERCENTAGE = "percent";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_COUNT = "count";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_COUNT_PER_SEC = "count_per_sec";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_BYTES = "bytes";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_KILOBYTES = "kilobytes";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_MEGABYTES = "megabytes";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_GIGABYTES = "gigabytes";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_TERABYTES = "terabytes";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_BYTES_PER_SEC = "bytes_per_sec";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_KILOBYTES_PER_SEC = "kilobytes_per_sec";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_MEGABYTES_PER_SEC = "megabytes_per_sec";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_GIGABYTES_PER_SEC = "gigabytes_per_sec";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_TERABYTES_PER_SEC = "terabytes_per_sec";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::UNIT_NONE = "none";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
MetricData_<ContainerAllocator>::NA_STRING = "non_applicable_string_value";

}  // namespace msg

}  // namespace ros_monitoring_msgs

#endif  // ROS_MONITORING_MSGS__MSG__METRIC_DATA__STRUCT_HPP_
