// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ros_monitoring_msgs:msg/MetricList.idl
// generated code does not contain a copyright notice

#ifndef ROS_MONITORING_MSGS__MSG__METRIC_LIST__FUNCTIONS_H_
#define ROS_MONITORING_MSGS__MSG__METRIC_LIST__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "ros_monitoring_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "ros_monitoring_msgs/msg/metric_list__struct.h"

/// Initialize msg/MetricList message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * ros_monitoring_msgs__msg__MetricList
 * )) before or use
 * ros_monitoring_msgs__msg__MetricList__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_ros_monitoring_msgs
bool
ros_monitoring_msgs__msg__MetricList__init(ros_monitoring_msgs__msg__MetricList * msg);

/// Finalize msg/MetricList message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ros_monitoring_msgs
void
ros_monitoring_msgs__msg__MetricList__fini(ros_monitoring_msgs__msg__MetricList * msg);

/// Create msg/MetricList message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * ros_monitoring_msgs__msg__MetricList__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ros_monitoring_msgs
ros_monitoring_msgs__msg__MetricList *
ros_monitoring_msgs__msg__MetricList__create();

/// Destroy msg/MetricList message.
/**
 * It calls
 * ros_monitoring_msgs__msg__MetricList__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ros_monitoring_msgs
void
ros_monitoring_msgs__msg__MetricList__destroy(ros_monitoring_msgs__msg__MetricList * msg);


/// Initialize array of msg/MetricList messages.
/**
 * It allocates the memory for the number of elements and calls
 * ros_monitoring_msgs__msg__MetricList__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_ros_monitoring_msgs
bool
ros_monitoring_msgs__msg__MetricList__Sequence__init(ros_monitoring_msgs__msg__MetricList__Sequence * array, size_t size);

/// Finalize array of msg/MetricList messages.
/**
 * It calls
 * ros_monitoring_msgs__msg__MetricList__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ros_monitoring_msgs
void
ros_monitoring_msgs__msg__MetricList__Sequence__fini(ros_monitoring_msgs__msg__MetricList__Sequence * array);

/// Create array of msg/MetricList messages.
/**
 * It allocates the memory for the array and calls
 * ros_monitoring_msgs__msg__MetricList__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ros_monitoring_msgs
ros_monitoring_msgs__msg__MetricList__Sequence *
ros_monitoring_msgs__msg__MetricList__Sequence__create(size_t size);

/// Destroy array of msg/MetricList messages.
/**
 * It calls
 * ros_monitoring_msgs__msg__MetricList__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ros_monitoring_msgs
void
ros_monitoring_msgs__msg__MetricList__Sequence__destroy(ros_monitoring_msgs__msg__MetricList__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // ROS_MONITORING_MSGS__MSG__METRIC_LIST__FUNCTIONS_H_
