#ifndef _H_8D24F6A1B42F1ED7A7DD209353073B57_MetricDimension_DCPS_H_
#define _H_8D24F6A1B42F1ED7A7DD209353073B57_MetricDimension_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MetricDimension_.h"


namespace ros_monitoring_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MetricDimension_TypeSupportInterface;

            typedef MetricDimension_TypeSupportInterface * MetricDimension_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MetricDimension_TypeSupportInterface> MetricDimension_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MetricDimension_TypeSupportInterface> MetricDimension_TypeSupportInterface_out;


            class MetricDimension_DataWriter;

            typedef MetricDimension_DataWriter * MetricDimension_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MetricDimension_DataWriter> MetricDimension_DataWriter_var;
            typedef DDS_DCPSInterface_out < MetricDimension_DataWriter> MetricDimension_DataWriter_out;


            class MetricDimension_DataReader;

            typedef MetricDimension_DataReader * MetricDimension_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MetricDimension_DataReader> MetricDimension_DataReader_var;
            typedef DDS_DCPSInterface_out < MetricDimension_DataReader> MetricDimension_DataReader_out;


            class MetricDimension_DataReaderView;

            typedef MetricDimension_DataReaderView * MetricDimension_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MetricDimension_DataReaderView> MetricDimension_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MetricDimension_DataReaderView> MetricDimension_DataReaderView_out;

            struct MetricDimension_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MetricDimension_, struct MetricDimension_Seq_uniq_> MetricDimension_Seq;
            typedef DDS_DCPSSequence_var < MetricDimension_Seq> MetricDimension_Seq_var;
            typedef DDS_DCPSSequence_out < MetricDimension_Seq> MetricDimension_Seq_out;

            class  MetricDimension_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MetricDimension_TypeSupportInterface_ptr _ptr_type;
                typedef MetricDimension_TypeSupportInterface_var _var_type;

                static MetricDimension_TypeSupportInterface_ptr _duplicate (MetricDimension_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricDimension_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MetricDimension_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricDimension_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricDimension_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MetricDimension_TypeSupportInterface () {};
                ~MetricDimension_TypeSupportInterface () {};
            private:
                MetricDimension_TypeSupportInterface (const MetricDimension_TypeSupportInterface &);
                MetricDimension_TypeSupportInterface & operator = (const MetricDimension_TypeSupportInterface &);
            };

            class  MetricDimension_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MetricDimension_DataWriter_ptr _ptr_type;
                typedef MetricDimension_DataWriter_var _var_type;

                static MetricDimension_DataWriter_ptr _duplicate (MetricDimension_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricDimension_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MetricDimension_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricDimension_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricDimension_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MetricDimension_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MetricDimension_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MetricDimension_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MetricDimension_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MetricDimension_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MetricDimension_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MetricDimension_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MetricDimension_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MetricDimension_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MetricDimension_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MetricDimension_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MetricDimension_& instance_data) = 0;

            protected:
                MetricDimension_DataWriter () {};
                ~MetricDimension_DataWriter () {};
            private:
                MetricDimension_DataWriter (const MetricDimension_DataWriter &);
                MetricDimension_DataWriter & operator = (const MetricDimension_DataWriter &);
            };

            class  MetricDimension_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MetricDimension_DataReader_ptr _ptr_type;
                typedef MetricDimension_DataReader_var _var_type;

                static MetricDimension_DataReader_ptr _duplicate (MetricDimension_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricDimension_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MetricDimension_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricDimension_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricDimension_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MetricDimension_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MetricDimension_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MetricDimension_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MetricDimension_& instance) = 0;

            protected:
                MetricDimension_DataReader () {};
                ~MetricDimension_DataReader () {};
            private:
                MetricDimension_DataReader (const MetricDimension_DataReader &);
                MetricDimension_DataReader & operator = (const MetricDimension_DataReader &);
            };

            class  MetricDimension_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MetricDimension_DataReaderView_ptr _ptr_type;
                typedef MetricDimension_DataReaderView_var _var_type;

                static MetricDimension_DataReaderView_ptr _duplicate (MetricDimension_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricDimension_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MetricDimension_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricDimension_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricDimension_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MetricDimension_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MetricDimension_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MetricDimension_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MetricDimension_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MetricDimension_& instance) = 0;

            protected:
                MetricDimension_DataReaderView () {};
                ~MetricDimension_DataReaderView () {};
            private:
                MetricDimension_DataReaderView (const MetricDimension_DataReaderView &);
                MetricDimension_DataReaderView & operator = (const MetricDimension_DataReaderView &);
            };
        }

    }

}

#endif
